from abc import ABC, abstractmethod

from cpl_query.extension import List

from gismo_data.model.server import Server


class ServerRepositoryABC(ABC):

    @abstractmethod
    def __init__(self): pass
    
    @abstractmethod
    def get_servers(self) -> List[Server]: pass
    
    @abstractmethod
    def get_server_by_id(self, id: int) -> Server: pass
    
    @abstractmethod
    def get_server_by_discord_id(self, discord_id: int) -> Server: pass
