from cpl_core.database.context import DatabaseContextABC
from cpl_query.extension import List
from gismo_data.abc.server_repository_abc import ServerRepositoryABC
from gismo_data.model.server import Server


class ServerRepositoryService(ServerRepositoryABC):

    def __init__(self, db_context: DatabaseContextABC):
        self._context = db_context

        ServerRepositoryABC.__init__(self)

    def get_servers(self) -> List[Server]:
        servers = List(Server)
        results = self._context.select(Server.get_select_all_string())
        for result in results:
            servers.append(Server(
                result[1],
                id=result[0]
            ))

        return servers

    def get_server_by_id(self, id: int) -> Server:
        result = self._context.select(Server.get_select_by_id_string(id))
        return Server(
            result[1],
            id=result[0]
        )

    def get_server_by_discord_id(self, discord_id: int) -> Server:
        result = self._context.select(Server.get_select_by_discord_id_string(discord_id))
        return Server(
            result[1],
            id=result[0]
        )
